(setq-default
 auto-hscroll-mode 'current-line
 dired-dwim-target t
 auto-window-vscroll nil
 apropos-do-all t
 make-backup-files nil
 auto-save-default nil
 warning-minimum-level :error
 create-lockfiles nil
 confirm-kill-emacs #'y-or-n-p
 delete-old-versions t
 display-line-numbers-widen nil
 display-line-numbers-current-absolute t
 echo-keystrokes 0.1
 enable-recursive-minibuffers t
 enable-local-variables t
 enable-local-eval t
 executable-prefix-env t
 fast-but-imprecise-scrolling t
 fill-column 80
 find-file-visit-truename t
 frame-resize-pixelwise t
 global-mark-ring-max 100
 ;; hscroll-margin 1
 ;; hscroll-step 1
 imenu-auto-rescan 1
 indent-tabs-mode nil
 inhibit-startup-screen t
 initial-buffer-choice t
 kept-new-versions 2
 kept-old-versions 2
 kill-do-not-save-duplicates t
 kill-read-only-ok t
 kill-ring-max 100
 kmacro-ring-max 20
 kill-buffer-query-functions nil
 load-prefer-newer t
 mark-ring-max 50
 mode-require-final-newline 'visit-save
 mouse-drag-copy-region t
 mouse-wheel-progressive-speed nil
 mouse-yank-at-point t
 read-answer-short t
 read-process-output-max (* 1024 1024)
 ring-bell-function 'ignore
 save-interprogram-paste-before-kill t
 ;; scroll-conservatively 101
 ;; scroll-down-aggressively 0.01
 ;; scroll-margin 1
 scroll-preserve-screen-position 1
 ;; scroll-step 1
 ;; scroll-up-aggressively 0.01
 search-ring-max 200
 sentence-end-double-space t
 set-mark-command-repeat-pop t
 show-paren-delay 0
 show-paren-when-point-in-periphery t
 show-paren-when-point-inside-paren t
 tramp-backup-directory-alist backup-directory-alist
 truncate-lines t
 truncate-string-ellipsis "…"
 tab-width 4
 undo-limit 100000000  ;; 10MB
 use-dialog-box nil
 use-file-dialog nil
 use-short-answers t
 vc-follow-symlinks t
 vc-make-backup-files t
 version-control t
 view-read-only t
 visible-bell nil
 frame-resize-pixelwise t
 frame-inhibit-implied-resize t
 yank-pop-change-selection t)

(setq-default
 locale-coding-system 'utf-8-unix
 coding-system-for-read 'utf-8-unix
 coding-system-for-write 'utf-8-unix
 buffer-file-coding-system 'utf-8-unix
 default-process-coding-system '(utf-8-unix . utf-8-unix)
 x-select-request-type '(UTF8_STRING COMPOUND_TEXT TEXT STRING))

(set-charset-priority 'unicode)
(set-language-environment "UTF-8")
(prefer-coding-system 'utf-8-unix)
(set-default-coding-systems 'utf-8-unix)
(set-terminal-coding-system 'utf-8-unix)
(set-keyboard-coding-system 'utf-8-unix)

(setq backup-directory-alist
      `(("." . ,(concat user-emacs-directory "backups"))))

(pcase system-type
  ((or 'ms-dos 'windows-nt)
   (set-clipboard-coding-system 'utf-16-le)
   (set-selection-coding-system 'utf-16-le))
  (_
   (set-selection-coding-system 'utf-8)
   (set-clipboard-coding-system 'utf-8)))

(dolist (disable-mode '(tooltip-mode
                        tool-bar-mode
                        menu-bar-mode
                        scroll-bar-mode
                        horizontal-scroll-bar-mode))
  (when (fboundp disable-mode)
    (funcall disable-mode -1)))

(setq-default mode-line-format (delq 'mode-line-modes mode-line-format))
(setq-default whitespace-style
              '(face spaces empty tabs newline trailing space-mark tab-mark newline-mark))
(setq-default notmuch-search-oldest-first nil)
